#########################################################
#               Created By:  Steve Cocks                #
#               Manage External Files                   #
#########################################################
#             Remember to visit my YaBB!                #
# http://www.stevecocks.com                             #
#########################################################

sub EditFile {

	&is_admin;
	
	$file = $INFO{'file'};
	
	my( $filetxt, $line );
	fopen(FILE, "$file");
	while( $line = <FILE> )
	{
		$line =~ tr/\r//d;
		$line =~ tr/\n//d;
		$line =~ s/&/&amp;/g;
		$line =~ s/</&lt;/g;
		$line =~ s/>/&gt;/g;
		$line =~ s/\|/\&#124;/g;
		$line =~ s/\%/&#37;/g;
		$line =~ s/"/&quot;/g;
		$filetxt .= qq~$line\n~;
	}
	fclose(FILE);
	
	$yymain = qq~
<table border=0 width="100%" cellspacing=1 bgcolor="$color{'bordercolor'}" class="bordercolor" cellpadding="4">
	<tr>
		<td class="titlebg" bgcolor="$color{'titlebg'}"><img src="$imagesdir/xx.gif" alt="" border="0">
		<font size=2 class="text1" color="$color{'titletext'}"><b>$exttxt{'3'} - $file</b></font>
		</td>
	</tr><tr>
		<td class="windowbg" bgcolor="$color{'windowbg'}">
		<BR><font size=1>$exttxt{'4'}</font><BR><BR>
		</td>
	</tr><tr>
		<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center"><font size=2>
			<form action="$cgi&action=editfile2" method="POST"><BR>
				<input type="hidden" name="file" value="$file">
				<textarea rows=30 cols=95 wrap=virtual name="filetxt" style="width:98%">$filetxt</textarea>
				<br><BR><input type=submit value="$txt{'10'}">
			</form>
			</font>
		</td>
	</tr>
</table>
~;

	$yytitle = "$exttxt{'8'} $file";
	&template;
	exit;
}

sub EditFile2
{
	&is_admin;
	
	$FORM{'filetxt'} =~ tr/\r//d;
	$FORM{'filetxt'} =~ s~\A\n~~;
	$FORM{'filetxt'} =~ s~\n\Z~~;
	
	$file = $FORM{'file'};

	fopen(FILE, ">$file");
	print FILE $FORM{'filetxt'};
	fclose(FILE);
	
	$yySetLocation = qq~$cgi&action=manageextfiles~;
	&redirectexit;
}

sub AddFile {

	&is_admin;
	
	fopen(FILE, "$vardir/externalfiles.txt");
	@files = <FILE>;
	fclose(FILE);
	foreach (@files) {
		$_ =~ s~[\n\r]~~g;
	}			
	fopen(FILE, ">$vardir/externalfiles.txt", 1);
	foreach $file (@files) {
		print FILE "$file\n";
	}
	$file = $FORM{'filename'};
	chomp $file;
	print FILE "$file\n";
	fclose(FILE);
	
	$yySetLocation = qq~$cgi&action=manageextfiles~;

	&redirectexit;
}

sub DeleteMultipleFiles {
	
	&is_admin;

	my ($currentfile);
	
	fopen(FILE, "$vardir/externalfiles.txt");
	@files = <FILE>;
	fclose(FILE);
	foreach (@files) {
	  $_ =~ s~[\n\r]~~g;
    }
    
	$count = 0;
	while (@files > $count) {
		$currentfile = $FORM{"file$count"};
		chomp $currentfile;
		if (exists $FORM{"file$count"}) {							
			unlink("$currentfile");	
			foreach $curfile (@files) {
				chomp $curfile;					
				if (lc $curfile eq lc $currentfile) {										
					$curfile = "*delete*";
				}
			}		
		}		
		$count++;
	}	
	fopen(FILE, ">$vardir/externalfiles.txt", 1);
	foreach $curfile (@files) {		
		if($curfile ne "*delete*") {
		  print FILE "$curfile\n"; 
		} 
	}
	fclose(FILE);	
	
	$yySetLocation = qq~$cgi&action=manageextfiles~;

	&redirectexit;
}

sub ManageExternalFiles {

	&is_admin;
	
	# Load file list
	fopen(FILE, "$vardir/externalfiles.txt");
	@filelist = <FILE>;
	fclose(FILE);
	foreach (@filelist) {
	  $_ =~ s~[\n\r]~~g;
    }
		
	$yymain = qq~      
<form action="$cgi&action=deletemultifiles" method="POST">
	<table border=0 cellspacing=0 cellpadding="3" align="center" width="85%">
		<tr>
			<td bgcolor="$color{'titlebg'}" align="center" class="titlebg">
		    <font size="2" class="text1" color="$color{'titletext'}"><B>$exttxt{'5'}</B></font>
		    </td>
		</tr>
	</table>
	<table border=0 width=85% align=center cellspacing="1" bgcolor="$color{'bordercolor'}" class="bordercolor">
		<tr>
	    	<td class="catbg" bgcolor="$color{'catbg'}" width="90%"><b><font size=2>$exttxt{'9'}</font></b></td>	      
	        <td class="catbg" bgcolor="$color{'catbg'}" width="10%"><b><font size=2><center>$exttxt{'10'}</center></font></b></td>
	    </tr>
~;

	$filenum = 0;
	foreach $file (@filelist) {
	$yymain .= qq~
	    <tr>
			<td class="windowbg" bgcolor="$color{'windowbg'}"><font size=2><a href="$cgi&action=editfile&file=$file">$file</a></font></td>
			<td class="windowbg" bgcolor="$color{'windowbg'}"><center><input type=checkbox name="file$filenum" value="$file"></center></td>
		</tr>
~;
		$filenum++;
	}
    $yymain .= qq~
		<tr>
	    <td colspan="2" class="windowbg" bgcolor="$color{'windowbg'}" align="center"><br><input type=submit value="$exttxt{'6'}"></td>
	    </tr>
	</table>
</form>
<br>   
<form action="$cgi&action=addfile" method="POST">
	<table border=0 cellspacing=0 cellpadding="0" align="center" width="85%">
		<tr>
	    	<td><input type=text name="filename" size="80"></td>
	        <td><input type=submit value="$exttxt{'7'}"></td>	      	        
	    </tr>	         
	</table>
</form>
~;

	$yytitle = $exttxt{'1'};
	&template;
	exit;
}

1;